#!/usr/bin/perl

use Gtk2;
use Gtk2Fu qw(:all);

sub create_and_fill_model {
    my $store = new Gtk2::ListStore(Glib::Boolean, Glib::String, Glib::String);

    # Append a row and fill in some data
#    my $store = Gtk2::TreeStore->new("Gtk2::Gdk::Pixbuf", map { "Glib::String" } 2..6);
    my $t = $store->append();
    $store->set($t, 0 => 0, 1 => 'Heinz El-Mann', 2 => 51);

    $t = $store->append();
    $store->set($t, 0 => 1, 1 => 'Jane Doe', 2 => 23);

    $t = $store->append();
    $store->set($t, 0 => 0, 1 => 'Joe Bungop', 2 => 91);

    $store
}

sub create_view_and_model {
    
    my $model = create_and_fill_model();

    my $view = new Gtk2::TreeView();

    my $renderer = new Gtk2::CellRendererToggle();
    $view->append_column(my $col = Gtk2::TreeViewColumn->new_with_attributes('F', $renderer, active => undef, ));
    my $r = $col->get_cell_renderers;
    $r->set(activatable => 1);
    $r->signal_connect (toggled => sub {
                            my ($renderer, $row, $col) = @_;
                            my $iter = $model->iter_nth_child (undef, $row);
                            my $val = $model->get ($iter, $col);
                            $model->set ($iter, $col, !$val);
                        }, $i);
    $col->set_sort_column_id(0);

    $renderer = new Gtk2::CellRendererText();
    $view->append_column(my $col = Gtk2::TreeViewColumn->new_with_attributes("Name", $renderer, 'text' => 1));
    #$view->insert_column_with_attributes(-1, "Name", $renderer, "text", 0);
    $col->set_sort_column_id(1);

    #my $col = new Gtk2::TreeViewColumn();
    $renderer = new Gtk2::CellRendererText();
    $view->insert_column_with_attributes(-1, "Age", $renderer, "text", 1);
    #$view->set_sort_column_id(2);

    $view->set_model($model);
    $view->signal_connect( row_activated => sub { print "ACTIVATED\n" });
    $view;
}


my $window = create_window('toplevel', 'test', 1, 0, 10);
$window->signal_connect(delete_event => sub { Gtk2->main_quit() });
my $view = create_view_and_model();
$window->add($view);
$window->show_all();
Gtk2->main;


